#ifndef PSTRUCTFUNCTIONS_H
#define PSTRUCTFUNCTIONS_H

#include "Pstruct.h"

class PstructInit : public eoInit<Pstruct>
{
public:
  
  PstructInit(std::string fasta_file, std::string _scoreFunc):
    inputFile(fasta_file),
    scoreFunc(_scoreFunc)
    {
    }
    

  void operator()(Pstruct & _pstruct)
  {
    _pstruct.create(inputFile, scoreFunc);
  }

 private :
  std::string inputFile;
  std::string scoreFunc;
};

class PstructEval : public eoEvalFunc<Pstruct>
{
public:

  void operator()(Pstruct & _pstruct)
  {
    _pstruct.fitness(_pstruct.evaluate());
      
  }
};


#endif
