#ifndef CONFSAMPLE_H
#define CONFSAMPLE_H


template< class P, class M >
class conformationalSample
{
 public:

   
  conformationalSample(M & _bbMover,
                       moSolContinue < P > & _continu,
                       eoEvalFunc < P > & _full_eval):
    bbMover(_bbMover),
    continu(_continu),
    full_eval(_full_eval)
    {
      
    }


    void operator ()(P & _solution)
    {
      P _new_solution = _solution;
      P _best_solution = _solution;
      
      continu.init();

      do 
        {
          bbMover.apply(_new_solution.myPose);
          full_eval(_new_solution);
          if (_new_solution.fitness()>_best_solution.fitness())
            _best_solution = _new_solution;
          else
            _new_solution = _best_solution;
        }
      while (continu(_solution));
      
      _solution = _best_solution;
      
      
    }


        private:
    M & bbMover;
    moSolContinue < P > & continu;
    eoEvalFunc < P > & full_eval;

};


#endif
    
