#ifndef PROTEINASPIRATIONCRITERION_H
#define PROTEINASPIRATIONCRITERION_H





template < class M, class P >
class proteinAspirationCriterion
{

 public:

  typedef typename P::Fitness Fitness;

  proteinAspirationCriterion (): first_time(true)
    {}

  void init ()
  {
    first_time = true;
  }


  bool operator () (const M & _move, const Fitness & _fitness)
  {
    const M move(_move);

    if (first_time)
      {
	best_fitness = _fitness;
	first_time = false;

	return true;
      }

    if (_fitness > best_fitness)
      {
    	best_fitness = _fitness;
    	return true;
      }   
    return false;
  }

 private:

  Fitness best_fitness;

  bool first_time;
};

#endif
