#ifndef PROTEINPERTURBATION_H
#define PROTEINPERTURBATION_H

#include "Pstruct.h"
#include "TsFragmentMover.h"


template <class M, class P, class S>
  class proteinPerturbation
{
  
 protected:
  M & mover;
  core::Size how_much;
  
  
 public :
  
  typedef typename M::EOType EOT;

  proteinPerturbation(M & _mover,
                      core::Size _how_much):
    mover(_mover),
    how_much(_how_much)
      {
      }
    virtual ~proteinPerturbation(){}
    bool virtual operator () (EOT & _sol)
    {
      S move;
      for (core::Size i=0; i<how_much;i++)
        {
          mover.select_move_key(move);
          mover(_sol, move);
          mover.registerAngles(_sol, move);
        }
      
      return true ;
    }
};



template <class M, class P, class S>
  class proteinSmartPerturbation: public proteinPerturbation<M,P,S>
{
  
 public :
 
  typedef typename M::EOType EOT;
 
  proteinSmartPerturbation(vector <double> & _contribs, M & _mover, core::Size _how_much):
    proteinPerturbation<M,P,S>(_mover, _how_much),
    contribs(_contribs)
      {
      }

    bool virtual operator()(EOT & _sol)
    {
      S move;
      for (core::Size i=0; i<this->how_much;i++)
        {
          this->mover.smart_select_move_key(move, contribs);
          this->mover(_sol, move);
          this->mover.registerAngles(_sol, move);
        }
      
      return true ;
    } 

 protected :
  vector<double> & contribs;

};





#endif
