#ifndef PROTEINSA_H
#define PROTEINSA_H

#include "proteinExplorerSA.h"
#include "keyStruct.h"

template < class M, class P, class S>
class proteinSA
{
  typedef typename M::EOType EOT;
  typedef typename EOT::Fitness Fitness;
  
 public :
  proteinSA ( proteinExplorerSA <M, P, S > & _explorer,
                moSolContinue < EOT > & _continu,
                eoEvalFunc < EOT > & _full_eval):
      explorer(_explorer),
      continu(_continu),
      full_eval(_full_eval)
        {

        }

    bool operator ()(EOT & _solution)
    {

      if ( _solution.invalid () )
      {
	full_eval (_solution);
      }
      
      
      
      EOT best_solution(_solution), new_solution(_solution);

      explorer.initParam(new_solution);
      continu.init ();
      explorer.init();
      
      do
        {
          explorer(new_solution);
          if (explorer.accept(_solution, new_solution))
            {
              _solution = new_solution;
              explorer.moveApplied(true);
              
              if (_solution.fitness() > best_solution.fitness())
                best_solution = _solution;
            }
          else
            {
              explorer.moveApplied(false);
              new_solution = _solution;
            }
          
          explorer.updateParam(new_solution);
          explorer.getWindow();
          
        }
      while (continu(new_solution));
      explorer.terminate(new_solution);
      _solution = best_solution;
      
      return true;
    }


 private :
    proteinExplorerSA < M, P, S > & explorer;
    moSolContinue < P > & continu;
    eoEvalFunc < P > & full_eval;
    
};

#endif
