#ifndef PROTEINTS_H
#define PROTEINTS_H

#include "proteinExplorer.h"

template < class M, class P>
class proteinTS
{
  typedef typename M::EOType EOT;
  typedef typename EOT::Fitness Fitness;
  
 public :
    proteinTS ( proteinExplorer < P > & _explorer,
                moSolContinue < EOT > & _continu,
                eoEvalFunc < EOT > & _full_eval):
      explorer(_explorer),
      continu(_continu),
      full_eval(_full_eval)
        {

        }

    bool operator ()(EOT & _solution)
    {

      if ( _solution.invalid () )
      {
	full_eval (_solution);
      }
      
      
      
      EOT best_solution(_solution), new_solution(_solution);

      continu.init ();
      
      do
        {
          explorer(_solution, new_solution);
          
          if (new_solution.fitness() > best_solution.fitness())
            {
              best_solution = new_solution;
            }
          _solution = new_solution;
          

        }
      while ( continu (_solution) );
      _solution = best_solution;
      
      return true;
    }



 private :
    proteinExplorer < P > & explorer;
    moSolContinue < EOT > & continu;
    eoEvalFunc < EOT > & full_eval;
    
};

#endif
