#ifndef PROTEINTABULIST_H
#define PROTEINTABULIST_H


template < class M, class P >
class proTabuListGeneric
{

 protected:
  
  unsigned int memory_maximum_size;
  unsigned int memory_size;
  
  
 public:

  typedef P EOT;

  proTabuListGeneric(unsigned int _memory_maximum_size):
    memory_maximum_size(_memory_maximum_size),
    memory_size(0)
      {}
    
    virtual ~proTabuListGeneric(){}

    virtual bool operator () (const M & _move, const EOT & _solution)=0;

    virtual void add(const M & _move, const EOT & _solution)=0;

    virtual void update ()=0;

    virtual void init ()=0;
    
    virtual void show ()=0;

};


template <class M, class P>
  class proteinTabuList:public proTabuListGeneric < M, P >
{
 public :
  
  typedef P EOT;
  typedef typename std::list<M>::iterator moveIterator;
  
  proteinTabuList(unsigned int _memory_maximum_size): proTabuListGeneric < M, P > (_memory_maximum_size)
    {}

    virtual bool operator () (const M & _move, const EOT & _solution)
    {
      moveIterator it;
      EOT solution=(EOT)_solution;
      
      it=tabuList.begin();

      while ( it!=tabuList.end() && !(*it==_move) )
        {
          it++;
        }
      
      return it!=tabuList.end();
    }
    
    virtual void add(const M & _move, const EOT & _solution)
    {
      const EOT solution(_solution);
      
      if (this->memory_size!=0)
        {
          removeMove(_move);
        }
      
      tabuList.push_back(_move);
      
      if (this->memory_size == this->memory_maximum_size)
        {
          tabuList.erase(tabuList.begin());
        }
      else
        {
          this->memory_size++;
        }
    }

    void show()
    {

      cout << "Code the function before calling it" << endl;

    }
    
    void update ()
    {
      //nothing to do
    }
    
    void init ()
    {
      //nothing to do
    }
    
 private:
    
    virtual void removeMove(const M & _move)
    {
      moveIterator it;
      
      it=tabuList.begin();

      while ( it!=tabuList.end() && (!((*it)==_move) ))
        {
          it++;
        }
      
      if (it!=tabuList.end())
        {
          tabuList.erase(it);
          this -> memory_size--;
        }
  }
    
    std::list<M> tabuList;
};









#endif


  
