#ifndef ROULETTEW_H
#define ROULETTEW_H
#include "keyStruct.h"

int roulette_wheel(const std::vector<keyStruct>& vec, double total = 1)
{
  if (!vec.size())
    {
      cout << "[roulette_wheel] WARNING: NO VECTOR IN INPUT" << endl;
      return 0;
    }
  if (total == 0)
    {
      for (unsigned    i = 0; i < vec.size(); i++)
        total += vec[i].value;
    }
  double fortune = rng.uniform()*total;
  unsigned i=0;
  for (i=0;i<vec.size()-1;i++)
    {
      fortune -= vec[i].value;
      if (fortune <= 0)
        break;
    }
  return vec[i].index;
}

int inverse_roulette_wheel(const std::vector<keyStruct>& vec, double total = 0)
{
  if (total == 0)
    {
      for (unsigned    i = 0; i < vec.size(); i++)
        total += (1 - vec[i].value);
    }
  double fortune = rng.uniform()*total;
  int i = 0;
  while (fortune > 0)
    {
      fortune -= (1 - vec[i++].value);
    }
  return vec[--i].index;
}


int roulette_wheel(const std::vector<double>& vec, double total = 1)
{
  if (!vec.size())
    {
      cout << "[roulette_wheel] WARNING: NO VECTOR IN INPUT" << endl;
      return 0;
    }
  if (total == 0)
    {
      for (unsigned    i = 0; i < vec.size(); i++)
        total += vec[i];
    }
  double fortune = rng.uniform()*total;
  unsigned i=0;
  for (i=0;i<vec.size()-1;i++)
    {
      fortune -= vec[i];
      if (fortune <= 0)
        break;
    }
  return i;
}



int uniform_wheel(const std::vector<keyStruct>& vec, double total = 0)
{
  if (total == 0)
    {
      total = vec.size();
    }
  int fortune = (int)( rng.uniform()*total);
  return vec[fortune].index;
}



#endif
